#!/usr/bin/perl

use strict;
use warnings;
use File::Temp qw( tempfile );
use bytes;

my $hex_challenge = $ARGV[0];
my $keyfile       = $ARGV[1];

$hex_challenge =~ s/://g;

my $data = pack("H*", $hex_challenge);

my ($TEMPH, $tempf) = tempfile();
open my $RSAUTL, "|openssl rsautl -raw -sign -inkey $keyfile -out $tempf";
print $RSAUTL $data;
close $RSAUTL;

my $signed_data = do {
    local $/;
    <$TEMPH>;
};
my @bytes;
for (my $i = 0; $i < length $signed_data; $i++) {
    push @bytes, sprintf "%02x", ord(substr($signed_data, $i, 1));
}
print join q{:}, @bytes;
