#include <stdlib.h>
#include <fcntl.h>
#include <sys/wait.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>

int
djbGetSetting(char* fn, char* buf, int maxlen)
{
	int f;
	int l;
	int i;
	char rfn[1024];

	snprintf(rfn, 1024, "%s/%s", getenv("HOME"), fn);

	f = open(rfn, O_RDONLY);
	if (f == -1) {
		return -1;
	}

	l = read(f, buf, maxlen - 1);
	if (l < 1) {
		buf[0] = 0;
		goto fin;
	}

	for (i = 0; i < l; i++) {
		switch(buf[i]) {
		case '\n':
		case '\r':
			l = i;
			goto ok;
		default:;
		}
	}
ok:
	buf[l] = 0;

fin:
	close(f);
	return l;
}

int
djbSetSetting(char* fn, char* buf)
{
	int f;
	int l;
	char rfn[1024];

	snprintf(rfn, 1024, "%s/%s", getenv("HOME"), fn);

	f = open(rfn, O_WRONLY | O_CREAT, 0600);

	if (f == -1) {
		return -1;
	}

	write(f, buf, strlen(buf));
	write(f, "\n", 1);

// fin:
	close(f);
	return l;
}
