#!/usr/bin/env python2.5

from sys import exit, argv, stderr
import sys
from os import popen
from time import time, sleep
from random import seed, random, randint
from pprint import pformat
import md5
import re
import socket

shit = {'parse': "Problem parsing ping result -- shouldn't happen!",
        'send' : "Problem sending packets -- no single ICMP send succeeded",
        'recv' : "Didn't receive a single ICMP response",
        'ilrp' : "Received illegal / wrong response",
        'nickreg' : "Unable to register nickname",
        'chanreg' : "Unable to register channel",
        'join' : "Unable to join channel / not alone in channel",
        'flag' : "Service delivered no flag / a wrong flag",
        'secret' : "Failed to set channel flag +s",
        'deop' : "Unable to deop myself",
        'op' : "Chanserv doesn't op me",
        'toomuch': "Script returned too much data",
        'allok' : "Everything is fine",
        'identify' : "Services Identify failed",
        'addannounce': "Addannounce failed",
        'nicknotregged' : "Previously registered nick was not registered anymore"}

PLUSTIME = 1800000000
if PLUSTIME < time():
	print "Fatal error! Edit this script and significantly increase PLUSTIME. Must be much larger than the current time."
	exit(-2)

class LineReader:
    def __init__(self, socket):
        self.s = socket
        self.buf = ''
    def readline(self):
        while True:
            pos = self.buf.find("\n")
            if pos != -1:
                line, self.buf = self.buf[:pos], self.buf[pos + 1:]
                return line
            frag = self.s.recv(8192)
            if len(self.buf) > 8192: raise EOFException()
            frag = frag.replace("\r", "")
            if (len(self.buf) == 0) and (len(frag) == 0): raise EOFException()
            if len(frag) == 0:
                buf, self.buf = self.buf, ''
                return buf # EOF
            self.buf = self.buf + frag
    def readlineparams(self):
        line = self.readline()
        # print "RECV: %s" % repr(line)
        line = line.split(" ", 1)
        try: line = line[1]
        except: line = line[0]
        parts = line.split(":", 1)
        sparts = parts[0].strip().split(" ")
        del parts[0]
        return sparts + parts

def invoke1997Command(host, cmdline):
    s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    s.connect((host, 1997))
    lr = LineReader(s)
    s.sendall("%s\n" % cmdline)
    s.shutdown(socket.SHUT_WR)
    lines = []
    while True:
        try: line = lr.readline()
        except: return lines
        else: lines.append(line)

class HathFlagException(Exception): pass
def hathflag(host, flag):
    flagpart = flag[0:8]
    res = invoke1997Command(host, "hath %s" % flagpart)[-1]
    print "HATHFLAG: %s" % res
    if res.endswith("\x00H"): return True
    if res.endswith("\x00DH"): return False
    raise HathFlagException("Errenous result")

def die(reason, exitcode = 5):
    try: msg = shit[reason]
    except: msg = reason
    stderr.write(msg)
    exit(exitcode)

def randflag():
    flagpart = "ABCDEFabcdef0123456789"
    return ''.join([flagpart[randint(0, len(flagpart) - 1)] for i in range(8)])

def check1997(host, flagid, flag):
    res = invoke1997Command(host, "ltca")[-1]
    print "LTCA: %s" % repr(res)
    res = invoke1997Command(host, "dlcf")[-1]
    print "DLCF: %s" % res
    print hathflag(host, randflag())
    while random() < 0.75:
        try:
            if hathflag(host, randflag()): die("TrustSlice says the bot application has been tampered with", 21)
        except HathFlagException, e: die("This service requires a functional TrustSlice", 9)
    try:
        if not hathflag(host, flag): die("TrustSlice says the bot application has been tampered with", 21)
    except HathFlagException, e: die("This service requires a functional TrustSlice", 9)
    print repr(res)

def expect(lr, pat, err = 'ilrp'):
    what = re.compile(pat)
    i = 0
    try:
        while True:
            line = lr.readline()
            i = i + 1
            if i > 128: die('toomuch')
            print "%s|  %s" % (pat, line)
            res = what.search(line)
            if res != None:
                print '>> found string %s (%s) <<' % (repr(pat), pformat(res.groups()))
                return res.groups()
    except:
        print "Didn't catch string %s" % pat
        die(err)

def getsock(): return socket.socket(socket.AF_INET, socket.SOCK_STREAM)
def store((ip, flagid, flag)):
    flagid = int(''.join([str(ord(i))[0:2] for i in flagid[0:7]])) + PLUSTIME
    print "Using FLAGID %d" % flagid
    seed(time())
    s = getsock()
    try: s.connect((ip, 1986))
    except:
        sys.stderr.write("Connection timed out / refused")
        sys.stderr.flush()
        exit(1)
    s.settimeout(10.0)
    lr = LineReader(s)
    if random() < 0.5:
        s.sendall("addannounce %d %s\n" % (flagid, flag))
        expect(lr, '(200) (.+)', 'addannounce')
    else:
        s.sendall("GET /cgi-bin/announce HTTP/1.0\n\n")
        sid, = expect(lr, '\\$SID ([0-9]+)\\$')
        print "Session ID == %s" % sid
        s.close()
        sleep(2)
        s = getsock()
        s.connect((ip, 1986))
        lr = LineReader(s)
        prevann = []
        while random() < 0.7:
                baz = str(random() * 1023043)
                prevann.append(baz)
                req = "GET /cgi-bin/announce/add?sessionid=%s&announcetime=%d&announce=%s HTTP/1.0\n\n" % (sid, flagid, baz)
                print req
                s.sendall(req)
                expect(lr, '(Announce added)', 'addannounce')
                s.close()
                sleep(2)
                s = getsock()
                s.connect((ip, 1986))
                lr = LineReader(s)
        s.sendall("GET /cgi-bin/announce/add?sessionid=%s&announcetime=%d&announce=%s HTTP/1.0\n\n" % (sid, flagid, flag))
        if len(prevann):
                print "Previous announces exist; checking if they're successfully returned"
                prevann.sort()
                expect(lr, prevann.pop(), 'addannounce')
        else:
                expect(lr, '(Announce added)', 'addannounce')
                
    
    print "===== SUCCESSFULLY STORED FLAG ====="
    die('allok', 0)

def retrieve((ip, flagid, flag)):
    flagid = int(''.join([str(ord(i))[0:2] for i in flagid[0:7]])) + PLUSTIME
    print "Using FLAGID %d" % flagid
    seed(time())
    check1997(ip, flagid, flag)
    s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    s.settimeout(10.0)
    try: s.connect((ip, 1986))
    except:
        sys.stderr.write("Connection timed out / refused")
        sys.stderr.flush()
        exit(1)
    lr = LineReader(s)
    if random() < 0.5:
            s.sendall("get %d\n" % flagid)
            expect(lr, "(%s)" % flag, 'flag')
    else:
            s.sendall("GET /cgi-bin/announce HTTP/1.0\n\n")
            sessid, = expect(lr, '\\$SID ([0-9]+)\\$', 'flag')
            s.close()
            s = getsock()
            s.connect((ip, 1986))
            lr = LineReader(s)
            s.sendall("GET /cgi-bin/announce/get?announceid=%d&sessionid=%s HTTP/1.0\n\n" % (flagid, sessid))
            expect(lr, "(%s)" % flag, 'flag')

    print "===== SUCCESSFULLY RETRIEVED FLAG ====="
    die('allok', 0)

def test((ip)):
    stderr.write("Testing is integrated in store/retrieve functionality.")
    exit(0) # service is fully functional

if __name__ == '__main__':
    {   'store': store,
        'retrieve': retrieve,
        'test': test
    }[argv[1]](tuple(argv[2:]))
try: pass
except SystemExit, e: exit(e.code)
except Exception, e:
    stderr.write("ERROR! ")
    stderr.write(str(e))
    print "Error: " + str(e)
    print "Usage: %s store|retrieve IP FLAGID FLAG" % argv[0]
    print "       %s test IP" % argv[0]
finally: stderr.flush()

#vim:set shiftwidth=4 tabstop=4 expandtab textwidth=79:

