#!/usr/bin/python2.5

from sys import exit, argv, stderr
import sys
from os import popen
from time import time
from random import seed, random
import md5
import re
import socket
import cgi

shit = {'parse': "Problem parsing ping result -- shouldn't happen!",
        'send' : "Problem sending packets -- no single ICMP send succeeded",
        'sendmail' : "The service won't let me send an email",
        'recv' : "Didn't receive a single ICMP response",
        'ilrp' : "Received illegal / wrong response",
        'nickreg' : "Unable to register nickname",
        'chanreg' : "Unable to register channel",
        'hello' : "Server didn't say hello properly",
        'join' : "Unable to join channel / not alone in channel",
        'flag' : "Service delivered no flag / a wrong flag",
        'register' : "Could not register a username",
        'deop' : "Unable to deop myself",
        'deop' : "Chanserv doesn't op me",
        'allok' : "Everything is fine",
        'identify' : "Services Identify failed",
        'nicknotregged' : "Previously registered nick was not registered anymore"}

names = [i.replace(' ', '_') for i in [
		'Dr. Frank Norbert Stein',
		'Heinz Peter Karl',
		'Prof. Schneider',
		'Franz Dr. Haus',
		'Maria',
		'JC Denton',
		'Mr. Manderley',
		'Walton Page',
		'Bob Simons',
		'Julian Zeri',
		'Albert Spangler',
		"Fred '130' Grad"
	]
]

class LineReader:
    buf = ''
    def __init__(self, socket):
        self.s = socket
    def readline(self):
        while True:
            pos = self.buf.find("\n")
            if pos != -1:
                line, self.buf = self.buf[:pos], self.buf[pos + 1:]
                return line
            frag = self.s.recv(8192)
            if frag == None: raise EOFException()
            if len(frag) == 0: raise EOFException()
            frag = frag.replace("\r", "")
            if len(frag) == 0:
                buf, self.buf = self.buf, ''
                return buf # EOF
            self.buf = self.buf + frag
    def readlineparams(self):
        line = self.readline()
        print "RECV: %s" % repr(line)
        line = line.split(" ")
        return line


def die(reason, exitcode = 5):
    try: msg = shit[reason]
    except: msg = "unknown reason"
    stderr.write(msg)
    exit(exitcode)

def expect(lr, row, what, err = 'ilrp', errcode = 5):
    try:
        while True:
            line = lr.readlineparams()
            if len(line) >= row:
                if line[row] == what:
                    print '>> found string %s in row %d <<' % (repr(what), row)
                    return
    except:
        print "Didn't catch string %s in row %d" % (what, row)
        die(err, errcode)

def store((ip, flagid, flag)):
    name = names[int(flagid[0], 36) % len(names)]
    passwd = md5.md5(flagid).hexdigest()
    print 'using name %(name)s' % {'name': name}
    print "connecting"
    s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    try: s.connect((ip, 8080))
    except:
        sys.stderr.write("Connection timed out / refused")
        sys.stderr.flush()
        exit(1)
    print "connected"
    s.settimeout(10.0)
    print "set timeout"
    lr = LineReader(s)
    print "instantiated linereader"
    print "sending"
    s.sendall("GET /smtp HTTP/1.0\n")
    print "sent"
    expect(lr, 0, 'To:', 'hello')
    s.sendall("%s\n" % name)
    expect(lr, 0, 'if', 'hello')
    s.sendall("flagid %s abc %s def %s ghi\n")
    expect(lr, 0, '>flagid', 'hello')
    s.sendall("abc def %d ghi jkl\n" % time())
    expect(lr, 4, 'transmission', 'send')
    s.sendall("abc\n%d\ndie flagge ist %s\n" % (time(), flag))
    expect(lr, 1, 'Characters', 'send')
    s.sendall(".\n")
    expect(lr, 0, '>flagid', 'send')
    s.close()

    print "connecting again"
    s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    try: s.connect((ip, 8080))
    except:
        sys.stderr.write("Connection timed out / refused")
        sys.stderr.flush()
        exit(1)
    print "connected"
    s.settimeout(10.0)
    print "set timeout"
    lr = LineReader(s)
    s.sendall("GET /reg?name=%s&pass=%s HTTP/1.0\n" % tuple([cgi.escape(i) for i in [name, passwd]]))
    expect(lr, 0, "Content-type:", 'register', 8)
    s.close() 
    print "===== STORED FLAG ====="
    die('allok', 0)

def retrieve((ip, flagid, flag)):
    name = names[int(flagid[0], 36) % len(names)]
    print 'using name %(name)s' % {'name': name}
    print "connecting"
    s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    try: s.connect((ip, 8080))
    except:
        sys.stderr.write("Connection timed out / refused")
        sys.stderr.flush()
        exit(1)
    s.settimeout(10.0)
    lr = LineReader(s)
    print "sending"
    print "===== SUCCESSFULLY RETRIEVED FLAG ====="
    die('allok', 0)

def test((ip)):
    stderr.write("Retrieving always succeeds")
    exit(0) # service is fully functional
    
try:
    {   'store': store,
        'retrieve': retrieve,
        'test': test
    }[argv[1]](tuple(argv[2:]))
except SystemExit, e: exit(e.code)
except Exception, e:
    stderr.write("ERROR! ")
    stderr.write(str(e))
    print "Error: " + str(e)
    print "Usage: %s store|retrieve IP FLAGID FLAG" % argv[0]
    print "       %s test IP" % argv[0]
finally: stderr.flush()
