#!/usr/bin/env python2.5

# (C)* 2008, HC Esperer

from sys import exit, argv, stderr
import sys
from os import popen
from time import time, sleep
from random import seed, random, randint
from pprint import pformat
from cPickle import dumps
from md5 import md5
import re
import socket

shit = {'parse': "Problem parsing ping result -- shouldn't happen!",
        'send' : "Problem sending packets -- no single ICMP send succeeded",
        'recv' : "Didn't receive a single ICMP response",
        'ilrp' : "Received illegal / wrong response",
        'nickreg' : "Unable to register nickname",
        'antispam': "Antispam handshake failed",
        'chanreg' : "Unable to register channel",
        'join' : "Unable to join channel / not alone in channel",
        'imap': '"IMAP" handshake failed',
        'flag' : "Service delivered no flag / a wrong flag",
        'secret' : "Failed to set channel flag +s",
        'deop' : "Unable to deop myself",
        'op' : "Chanserv doesn't op me",
	'blacklist': "Blacklist functionality is broken",
        'toomuch': "Script returned too much data",
        'allok' : "Everything is fine",
        'identify' : "Services Identify failed",
        'smtpgreet': "SMTP handshake failed",
        'addannounce': "Addannounce failed",
        'nicknotregged' : "Previously registered nick was not registered anymore"}

PLUSTIME = 1800000000
if PLUSTIME < time():
	print "Fatal error! Edit this script and significantly increase PLUSTIME. Must be much larger than the current time."
	exit(-2)

class LineReader:
    def __init__(self, socket):
        self.s = socket
        self.buf = ''
    def readline(self):
        while True:
            pos = self.buf.find("\n")
            if pos != -1:
                line, self.buf = self.buf[:pos], self.buf[pos + 1:]
                return line
            frag = self.s.recv(8192)
            if len(self.buf) > 8192: raise EOFException()
            frag = frag.replace("\r", "")
            if (len(self.buf) == 0) and (len(frag) == 0): raise EOFException()
            if len(frag) == 0:
                buf, self.buf = self.buf, ''
                return buf # EOF
            self.buf = self.buf + frag
    def readlineparams(self):
        line = self.readline()
        # print "RECV: %s" % repr(line)
        line = line.split(" ", 1)
        try: line = line[1]
        except: line = line[0]
        parts = line.split(":", 1)
        sparts = parts[0].strip().split(" ")
        del parts[0]
        return sparts + parts

def die(reason, exitcode = 5):
    try: msg = shit[reason]
    except: msg = reason
    stderr.write(msg)
    exit(exitcode)

def randflag():
    flagpart = "ABCDEFabcdef0123456789"
    return ''.join([flagpart[randint(0, len(flagpart) - 1)] for i in range(8)])

def expect(lr, pat, err = 'ilrp', errcode=5):
    what = re.compile(pat)
    i = 0
    try:
        while True:
            line = lr.readline()
            i = i + 1
            if i > 128: die('toomuch')
            print "%s|  %s" % (pat, line)
            res = what.search(line)
            if res != None:
                print '>> found string %s (%s) <<' % (repr(pat), pformat(res.groups()))
                return res.groups()
    except:
        print "Didn't catch string %s" % pat
        die(err, errcode)

def getsock(): return socket.socket(socket.AF_INET, socket.SOCK_STREAM)
def makeaufgabe():
        def operator():
                operators = "+-/*"
                return operators[randint(0, len(operators) - 1)]
        term = "%d%s(%d%s%d)" % (randint(1, 10), operator(), randint(1, 10), operator(), randint(1, 10))
        return term

def randomsender():
    senders = [
            ("Bobi Logi", "bobi@logi.com.us.aquinas"),
            ("Thomas Aquinas", "taquinas@germanyoffline.com.de.aquinas"),
            ("Harleen Quinzelle", "harlequin@runmother.com.us.aquinas"),
            ("P.", "paul@ton.hk.nyc.com.us.aquinas")
        ]
    return senders[randint(0, len(senders) - 1)]

bltest = [
    (('bessere internet jetztEINS!ELF', 'marketing@2or2.de'), True),
    (('Dr. Page', 'drpage@priv.versalive.com.hk.aquinas'), False),
    (('Dr. B. Andrews', 'bandrews@luckymoney.nl.com.hk.aquinas'), False),
    (('Deutschland Offline', 'freeinternet@germanyoffline.de'), True),
    (('Alexander Realfraud', 'spamming@alexr.com'), True),
    (('C. Lynch', 'clynch@foo.mil'), False)
]

def checkbl(s, lr):
    while random() < 0.8:
        addr, isblocked = bltest[randint(0, len(bltest) - 1)]
        checkblock(s, lr, addr, isblocked)
        if not isblocked: return # our SMTP server doesn't support multiple FROM: statements ;-)

def checkblock(s, lr, addr, isblocked):
    print "Doing BL check on %s <%s>..." % addr
    s.sendall("mail from: %s <%s>\n" % addr)
    expect(lr, "^%d" % {True: 451, False: 250}[isblocked], 'blacklist', 9)


def store((ip, flagid, flag)):
    flagid = flagid[0:8]
    print "Using FLAGID %s" % flagid
    seed(time())
    s = getsock()
    try: s.connect((ip, 2525))
    except:
        sys.stderr.write("Connection timed out / refused")
        sys.stderr.flush()
        exit(1)
    s.settimeout(10.0)
    lr = LineReader(s)

    # We're the askee
    expect(lr, '220 .*', 'greeting')
    expect(lr, '220 .*', 'greeting')
    aufgabe = expect(lr, '220 (.*)', 'antispam', 25)[0]
    parts = re.compile("([0-9]+)([-+]).([0-9]+)([-+])([0-9]+).")
    expr = parts.search(aufgabe)
    if expr == None: die('Illegal mathematical term', 25)
    expr = expr.groups()
    expr = "%s(%s)" % ("".join(expr[0:2]), "".join(expr[2:5]))
    result = eval(expr)
    s.sendall("%d\n" % result)
    expect(lr, "220 YO", 'antispam', 25)

    s.sendall("helo smtpgateway%d.mu.lower.dconn.aquinas\n" % randint(1, 104382))
    expect(lr, "^250", 'smtpgreet', 25)
    s.sendall("mail from: %s <%s>\n" % randomsender())
    expect(lr, "^250", 'smtpgreet', 25)
    s.sendall("rcpt to: abc defg <ayb%s@%s.de.aquinas>\n" % (flagid, dumps(randint(1, 4938523432)).encode('base64').replace("\n", "")))
    expect(lr, "^250", 'smtpgreet', 25)
    s.sendall("data\n")
    expect(lr, "^354", 'smtpgreet', 25)
    s.sendall("""Hello World, how are you today?
This is great! Check it out:
http://go.to.bigurl.aquinas/jump.exe?loadmodule=jumpredir.dll&whatistheurl=theurlis+youwouldn'taguessedthat+%s
Would ya?
.
""" % flag)
    s.sendall("quit\n")
    
    print "===== SUCCESSFULLY STORED FLAG ====="
    die('allok', 0)

def retrieve((ip, flagid, flag)):
    flagid = flagid[0:8]
    seed(time())
    s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    s.settimeout(10.0)
    try: s.connect((ip, 2525))
    except:
        sys.stderr.write("Connection timed out / refused")
        sys.stderr.flush()
        exit(1)
    lr = LineReader(s)

    # We're the askee
    expect(lr, '220 .*', 'greeting')
    expect(lr, '220 .*', 'greeting')
    aufgabe = expect(lr, '220 (.*)', 'antispam', 25)[0]
    parts = re.compile("([0-9]+)([-+]).([0-9]+)([-+])([0-9]+).")
    expr = parts.search(aufgabe)
    if expr == None: die('Illegal mathematical term', 25)
    expr = expr.groups()
    expr = "%s(%s)" % ("".join(expr[0:2]), "".join(expr[2:5]))
    result = eval(expr)
    s.sendall("%d\n" % result)
    expect(lr, "220 YO", 'antispam', 25)

    # We're the asker
    aufgabe = makeaufgabe()
    raufgabe = eval(aufgabe)
    s.sendall("antispam %s\n" % aufgabe)
    res = expect(lr, '666-[^ ]+ ([-0-9]+)', 'antispam', 25)[0]
    try: res = int(res)
    except: res = 0
    if raufgabe != res:
            print "%s != %d" % (aufgabe, res)
            die('antispam', 25)

    # say helo
    s.sendall("helo localhost.com\n")
    expect(lr, "^250", 'smtpgreet', 25)

    checkbl(s, lr)

    # create an account and login
    randpwd = md5(flagid).hexdigest()[2:8]
    s.sendall("createuser ayb%s %s\n" % (flagid, randpwd))
    s.sendall("login ayb%s %s\n" % (flagid, randpwd))
    s.sendall("iam %s\n" % flagid)
    expect(lr, "^678", 'imap', 25)
    s.sendall("retrievemail ayb%s\n" % flagid)
    expect(lr, "^523-.*(%s)$" % flag, 'flag', 5)
    s.sendall("quit\n")

    print "===== SUCCESSFULLY RETRIEVED FLAG ====="
    die('allok', 0)

def test((ip)):
    stderr.write("Testing is integrated in store/retrieve functionality.")
    exit(0) # service is fully functional

if __name__ == '__main__':
    {   'store': store,
        'retrieve': retrieve,
        'test': test
    }[argv[1]](tuple(argv[2:]))
try: pass
except SystemExit, e: exit(e.code)
except Exception, e:
    stderr.write("ERROR! ")
    stderr.write(str(e))
    print "Error: " + str(e)
    print "Usage: %s store|retrieve IP FLAGID FLAG" % argv[0]
    print "       %s test IP" % argv[0]
finally: stderr.flush()

# *Can you actually copyright a mess like this?
#vim:set shiftwidth=4 tabstop=4 expandtab textwidth=79:

