/*
 * PLACEFLAGHERE
 */
import java.io.*;
import java.util.*;
import java.lang.*;

public class Quicksort {
	private static Object[] getList(String filename) {
		BufferedReader in;
		String tmpstring;
		Integer tmpint;
		List<Integer> order = new ArrayList<Integer>();

		// Try to open file
		try {
			in = new BufferedReader(new FileReader(filename));
		} catch (IOException e) {
			System.err.println("Can't open inputfile");
			return order.toArray();
		}

		// Read each line
		try {
			while((tmpstring = in.readLine()) != null) {
				// Get int and append to list
				tmpint = new Integer(tmpstring);
				order.add(tmpint);
			}
		} catch (IOException e) {
			System.err.println("Error reading line");
			return order.toArray();
		}

		// Done reading input
		try {
			in.close();
		} catch (IOException e) {
			System.err.println("Can't close inputfile");
		}

		return order.toArray();
	}

	private static void swap(Object[] in, int i, int j) {
		Object temp = in[i];
		in[i] = in[j];
		in[j] = temp;
	}

	private static void quicksort(Object[] in, int left, int right) {
		if(right > left) {
			int pivotIndex = left;

			for(int i = left; i <= right; i++) {
				Integer tmp1 = (Integer)in[i];
				Integer tmp2 = (Integer)in[pivotIndex];
				if(tmp1 < tmp2) {
					swap(in, i, pivotIndex);
					pivotIndex = i;
				}
			}
			quicksort(in, left, pivotIndex);
			quicksort(in, pivotIndex+1, right);
		}
	}

	public static void main(String[] args) {
		Object[] order;

		// We need an input file
		if(args.length != 1) {
			return;
		}

		// Here is our workload
		order = getList(args[0]);

		// Sort it
		quicksort(order, 0, order.length);

		// Output it
		for(int i = 0; i < order.length; i++) {
			System.out.println(order[i]);
		}
	}
}
